import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;

class Main extends Frame implements ActionListener {
    Main() {
        super("ActionListener Example");
        setFont(new Font("Monospaced", Font.PLAIN, 12));
    
        // Create the 256 buttons.
        Panel p = new Panel(new GridLayout(16, 0));
        for (int i=0; i<256; i++) {
            Button b = new Button("" + (char)i);

            // If control character, display hex value.
            if (Character.isISOControl((char)i)) {
                String s = "0" + Integer.toHexString(i).toUpperCase();

                b.setLabel(s.substring(s.length()-2));
            }

            b.setName(""+(char)i);

            // Listen for events.
            b.addActionListener(this);

            // Add to panel.
            p.add(b);
        }

        // Layout and show components.
        add(p, BorderLayout.CENTER);
        pack();
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        // Fetch the character.
        char c = ((Component)evt.getSource()).getName().charAt(0);

        // Format the unicode string for 'c'.
        String result = "\\u00" + Integer.toHexString(c&0xff);

        // Place result in system clipboard.
        StringSelection contents = new StringSelection(result);
        getToolkit().getSystemClipboard().setContents(contents, null);
    }

    public static void main(String args[]) {
        new Main();
    }
}
