import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements AdjustmentListener {
    Main() {
        super("AdjustmentEvent Example");
        Scrollbar sb = new Scrollbar(Scrollbar.HORIZONTAL);

        // Listen for adjustment events.
        sb.addAdjustmentListener(this);

        add(sb, BorderLayout.CENTER);
        pack();
        show();
    }

    public void adjustmentValueChanged(AdjustmentEvent evt) {
        System.out.println("adjustable: "+evt.getAdjustable());
        switch (evt.getAdjustmentType()) {
          case AdjustmentEvent.BLOCK_DECREMENT:
            System.out.print("BLOCK_DECREMENT");
            break;
          case AdjustmentEvent.BLOCK_INCREMENT:
            System.out.print("BLOCK_INCREMENT");
            break;
          case AdjustmentEvent.TRACK:
            System.out.print("TRACK");
            break;
          case AdjustmentEvent.UNIT_DECREMENT:
            System.out.print("UNIT_DECREMENT");
            break;
          case AdjustmentEvent.UNIT_INCREMENT:
            System.out.print("UNIT_INCREMENT");
            break;
        }
        System.out.println("  ("+evt.getValue()+")");
    }
    
    public static void main(String args[]) {
        new Main();
    }
}
