import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Main() {
        super("KEY_TYPED Example");

        add(new MyTextArea(), BorderLayout.CENTER);
        pack();
        show();
    }

    public static void main(String args[]) {
        new Main();
    }
}

class MyTextArea extends TextArea {
    Object[] macros = {
        new Integer(KeyEvent.VK_F1), "class ",
        new Integer(KeyEvent.VK_F2), "interface ",
        new Integer(KeyEvent.VK_F3), "extends ",
        new Integer(KeyEvent.VK_F4), "implements ",
        new Integer(KeyEvent.VK_F5), "// author: pchan & rlee ",};

    MyTextArea() {
        enableEvents(AWTEvent.KEY_EVENT_MASK);
        setFont(new Font("Courier", Font.PLAIN, 14));
    }

    public void processKeyEvent(KeyEvent evt) {
        if (evt.getID() == KeyEvent.KEY_PRESSED) {
            for (int i=0; i<macros.length; i+=2) {
                Integer ri = (Integer)macros[i];
    
                if (ri.intValue() == evt.getKeyCode()) {
                    synthesizeKeyEvent((String)macros[i+1],
                        evt.isShiftDown());
                    evt.consume();
                    break;
                }
            }
        }
        super.processKeyEvent(evt);
    }

    void synthesizeKeyEvent(String s, boolean uppercase) {
        for (int j=0; j<s.length(); j++) {
            char ch = s.charAt(j);

            if (uppercase) {
                ch = Character.toUpperCase(ch);
            }

            KeyEvent ke = new KeyEvent(MyTextArea.this, 
                KeyEvent.KEY_TYPED, 
                System.currentTimeMillis(), 0, 
                KeyEvent.VK_UNDEFINED, ch);

            getToolkit().getSystemEventQueue().postEvent(ke);
        }
    }
}
