import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Main() {
        super("KeyEvent Example");
        TextField tf = new TextField();

        // Listen for text events.
        tf.addKeyListener(new KeyEventHandler());
        tf.setFont(new Font("Courier", Font.PLAIN, 14));

        add(tf, BorderLayout.CENTER);
        pack();
        show();
    }

    class KeyEventHandler extends KeyAdapter {
        public void keyPressed(KeyEvent evt) {
            printKey(evt);
        }
        public void keyReleased(KeyEvent evt) {
            printKey(evt);
        }
        public void keyTyped(KeyEvent evt) {
            printKey(evt);
        }

        void printKey(KeyEvent evt) {
            switch (evt.getID()) {
              case KeyEvent.KEY_TYPED:
                System.out.print("KEY_TYPED");
                break;
              case KeyEvent.KEY_PRESSED:
                System.out.print("KEY_PRESSED");
                break;
              case KeyEvent.KEY_RELEASED:
                System.out.print("KEY_RELEASED");
                break;
            }
            System.out.print(": char="+evt.getKeyChar()
                +"("+(int)evt.getKeyChar()+")");
            System.out.print(" code="+evt.getKeyCode());
            if (evt.isActionKey()) {
                System.out.print(" actionkey");
            }
            System.out.println();
        }
    }
    
    public static void main(String args[]) {
        new Main();
    }
}
