import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    String curKeyCode = "";
    String curModifiers = "";

    Main() {
        super("getKeyText Example");

        // Listen for text events.
        addKeyListener(new KeyEventHandler());

        setSize(200, 100);
        show();
    }

    public void paint(Graphics g) {
        Insets in = getInsets();
        FontMetrics fm = g.getFontMetrics();
        String s = curModifiers + " " + curKeyCode;

        g.drawString(s, (getSize().width-fm.stringWidth(s))/2, 
            in.top+(getSize().height-in.top-in.bottom-
                    fm.getHeight())/2+fm.getAscent());
    }

    class KeyEventHandler extends KeyAdapter {
        public void keyPressed(KeyEvent evt) {
            curKeyCode = KeyEvent.getKeyText(evt.getKeyCode());
            curModifiers = KeyEvent.getKeyModifiersText(evt.getModifiers());
            repaint();
        }
    }
    
    public static void main(String args[]) {
        new Main();
    }
}
