import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ItemListener {
    Color[] cbColor = {Color.red, Color.green, Color.blue};
    String[] cbName = {"Red", "Green", "Blue"};
    MainCanvas[] cbCanvas = new MainCanvas[3];
    CheckboxGroup cgroup = new CheckboxGroup();

    Main() {
        super("CheckboxGroup Example");
        Panel p = new Panel(new GridLayout(0, 1)), 
              colorPanel = new Panel(new GridLayout(1, 0));

        for (int i=0; i<cbColor.length; i++) {
            Checkbox cb = new Checkbox(cbName[i], cgroup, i == 0);
            p.add(cb);
            cb.addItemListener(this);
            colorPanel.add(cbCanvas[i] = new MainCanvas(cbColor[i], cb));
            cbCanvas[i].setSize(70, 70);
        }
        add(p, BorderLayout.WEST); 
        add(colorPanel, BorderLayout.CENTER); 
        pack();
        show();
    }

    public void itemStateChanged(ItemEvent evt) {
        // Update canvases when checkbox pressed
        for (int i=0; i<cbCanvas.length; i++) {
            cbCanvas[i].repaint();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    Checkbox cb;

    MainCanvas(Color color, Checkbox cb) {
        setBackground(color);
        this.cb = cb;
        addMouseListener(new MouseListener());
    }

    public void paint(Graphics g) {
        if (cb.getCheckboxGroup().getSelectedCheckbox() == cb) {
            Dimension d = getSize();
            g.setColor(Color.black);
            g.fillOval(d.width/3, d.height/3, d.width/3, d.height/3);
        }
    }

    class MouseListener extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            // Update checkbox group
            cb.getCheckboxGroup().setSelectedCheckbox(cb);

            // Update all sibling canvases.
            for (int i=0; i<getParent().getComponentCount(); i++) {
                getParent().getComponent(i).repaint();
        }
    }
  }
}
