import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {

    Main() {
        super("dispatchEvent Example");

        setLayout(new FlowLayout());
        Button b;
        add(b = new MainButton("SmallFont"));
        b.addActionListener(this);
        add(b = new MainButton("LargeFont"));
        b.addActionListener(this);

        setSize(200, 200);
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        String arg = evt.getActionCommand();
        Font f = null;

        if ("SmallFont".equals(arg)) {
            f = new Font("Serif", Font.PLAIN, 12);
        } else if ("LargeFont".equals(arg)) {
            f = new Font("Serif", Font.PLAIN, 30);
        }
        if (f != null) {
            SetFontEvent fevt = new SetFontEvent(this, f);
            for (int i=0; i<getComponentCount(); i++) {
                Component c = getComponent(i);
                c.dispatchEvent(fevt);
            }
        }
        doLayout();
    }

    public static void main(String[] args) {
        new Main();
    }
}

// Define new event for setting font of button
class SetFontEvent extends ActionEvent {
    Font font;
    public static final int SET_FONT_EVENT =  AWTEvent.RESERVED_ID_MAX + 1;
    public SetFontEvent(Object source, Font f) {
        super(source, SET_FONT_EVENT, null);
        font = f;
    }
    public Font getFont() {
        return font;
    }
}

class MainButton extends Button {
    MainButton(String label) {
        super(label);
    }

    // Override to handle special new event (SetFontEvent)
    protected void processActionEvent(ActionEvent evt) {
        if (evt instanceof SetFontEvent) {
            // Change font as requested
            setFont(((SetFontEvent)evt).getFont());
            invalidate();    // invalid button so it'll get resized
        } else {
            // Handle normal ActionEvent as before
            super.processActionEvent(evt);
        }
    }
}
