import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    public static void main(String args[]) {
        Frame f = new Frame("processEvent Example");
        MainList l = new MainList(4, true);

        for (int i=0; i<4; i++) {
            l.addItem("item "+i);
        }

        f.add(l, BorderLayout.CENTER);
        f.pack();
        f.show();
    }
}

class MainList extends List {
    public MainList(int rows, boolean multipleMode) {
        super(rows, multipleMode);

        enableEvents(-1);    // Enable all events.
    }

    protected void processEvent(AWTEvent evt) {
        int id = evt.getID();

        if (id >= ActionEvent.ACTION_FIRST && id <= ActionEvent.ACTION_LAST) {
            System.out.println("action event("+id+")");
        } else if (id >= AdjustmentEvent.ADJUSTMENT_FIRST 
            && id <= AdjustmentEvent.ADJUSTMENT_LAST) {
            System.out.println("adjustment event("+id+")");
        } else if (id >= ComponentEvent.COMPONENT_FIRST && 
                   id <= ComponentEvent.COMPONENT_LAST) {
            System.out.println("component event("+id+")");
        } else if (id >= ContainerEvent.CONTAINER_FIRST && 
                   id <= ContainerEvent.CONTAINER_LAST) {
            System.out.println("container event("+id+")");
        } else if (id >= WindowEvent.WINDOW_FIRST && 
                   id <= WindowEvent.WINDOW_LAST) {
            System.out.println("window event("+id+")");
        } else if (id >= FocusEvent.FOCUS_FIRST && 
                   id <= FocusEvent.FOCUS_LAST) {
            System.out.println("focus event("+id+")");
        } else if (id >= ItemEvent.ITEM_FIRST && id <= ItemEvent.ITEM_LAST) {
            System.out.println("item event"+id+")");
        } else if (id >= KeyEvent.KEY_FIRST && id <= KeyEvent.KEY_LAST) {
            System.out.println("key event"+id+")");
        } else if (id >= MouseEvent.MOUSE_FIRST && 
                   id <= MouseEvent.MOUSE_LAST) {
            System.out.println("mouse event"+id+")");
        } else if (id >= TextEvent.TEXT_FIRST && id <= TextEvent.TEXT_LAST) {
            System.out.println("text event"+id+")");
        }
        super.processEvent(evt);
    }
}
