import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    int borderSize = 8;
    Main() {
        super("getInsets Example");

        // Listen for mouse events
        addMouseMotionListener(new MouseMotionEventHandler());

        Button b = new Button("Button");
        add(b, BorderLayout.CENTER);

        // Disable button to let mouse motion events pass through
        b.setEnabled(false);
        setSize(150, 200);
        show();
    }

    class MouseMotionEventHandler extends MouseMotionAdapter {
        public void mouseMoved(MouseEvent evt) {
            System.out.println(evt.getX() + "," + evt.getY());
        }
    }

    public Insets getInsets() {
        Insets insets = (Insets)(super.getInsets()).clone();

        insets.top += borderSize;
        insets.left += borderSize;
        insets.bottom += borderSize;
        insets.right += borderSize;
        return insets;
    }

    public void paint(Graphics g) {
        Insets insets = super.getInsets();
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;

        g.setColor(new Color(200, 100, 100));
        for (int i=0; i<borderSize; i++) {
            g.draw3DRect(i+insets.left, i+insets.top, 
                         w-2*i-1, h-2*i-1, i<borderSize/2);
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}

