import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ActionListener {
    Component centerButton;
    GridBagLayout gbl = new GridBagLayout();

    Main() {
        super("anchor Example");
        GridBagConstraints c = new GridBagConstraints();

        setLayout(gbl);
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1;
        c.weighty = 1;

        makeButton(this, "nw", c, 0, 0);
        makeButton(this, "n", c, 1, 0);
        makeButton(this, "ne", c, 2, 0);
        makeButton(this, "w", c, 0, 1);
        makeButton(this, "e", c, 2, 1);
        makeButton(this, "sw", c, 0, 2);
        makeButton(this, "s", c, 1, 2);
        makeButton(this, "se", c, 2, 2);

        //   Make center button.
        c.fill = GridBagConstraints.NONE;
        centerButton = makeButton(this, "c", c, 1, 1);

        setSize(200, 200);
        show();
    }

    Component makeButton(Container cont, String label, 
            GridBagConstraints c, int x, int y) {
        GridBagLayout gbl = (GridBagLayout)cont.getLayout();
        Button b = new Button(label);

        cont.add(b);
        c.gridx = x;
        c.gridy = y;
        gbl.setConstraints(b, c);
        b.addActionListener(this);
        return b;
    }

    public void actionPerformed(ActionEvent evt) {
        String arg = evt.getActionCommand();
        GridBagConstraints c = gbl.getConstraints(centerButton);
        
        if ("n".equals(arg)) {
            c.anchor = GridBagConstraints.NORTH;
        } else if ("s".equals(arg)) {
            c.anchor = GridBagConstraints.SOUTH;
        } else if ("e".equals(arg)) {
            c.anchor = GridBagConstraints.EAST;
        } else if ("w".equals(arg)) {
            c.anchor = GridBagConstraints.WEST;
        } else if ("nw".equals(arg)) {
            c.anchor = GridBagConstraints.NORTHWEST;
        } else if ("ne".equals(arg)) {
            c.anchor = GridBagConstraints.NORTHEAST;
        } else if ("sw".equals(arg)) {
            c.anchor = GridBagConstraints.SOUTHWEST;
        } else if ("se".equals(arg)) {
            c.anchor = GridBagConstraints.SOUTHEAST;
        } else if ("c".equals(arg)) {
            c.anchor = GridBagConstraints.CENTER;
        }
        gbl.setConstraints(centerButton, c);
        invalidate();
        validate();
    }

    static public void main(String[] args) {
        new Main();
    }
}
