import java.awt.*;

public class Main {
    static void makeCrazyLayout() {
        Frame f = new 
            Frame("GridBagLayout Example 1");

        f.setLayout(new GridBagLayout());
        makeButton(f, "A", 0, 0, 1, 2, 0.0, 
            0.0);
        makeButton(f, "B", 1, 0, 4, 1, 2.0, 
            0.0);
        makeButton(f, "C", 1, 1, 2, 1, 0.0, 
            0.0);
        makeButton(f, "D", 3, 1, 2, 2, 0.0, 
            2.0);
        makeButton(f, "E", 0, 2, 2, 2, 0.0, 0.0);
        makeButton(f, "F", 1, 4, 1, 1, 0.5, 0.0);
        makeButton(f, "G", 2, 2, 1, 3, 0.0, 0.0);
        makeButton(f, "H", 3, 4, 1, 1, 0.0, 0.0);
        makeButton(f, "I", 4, 3, 1, 1, 1.0, 0.5);
        f.pack();
        f.show();
    }

    static void makeBorderLayout() {
        Frame f = new Frame("GridBagLayout Example 2");

        f.setLayout(new GridBagLayout());
        makeButton(f, "North", 0, 0, 3, 1, 0.0, 0.0);
        makeButton(f, "South", 0, 2, 3, 1, 0.0, 0.0);
        makeButton(f, "West", 0, 1, 1, 1, 0.0, 1.0);
        makeButton(f, "East", 2, 1, 1, 1, 0.0, 1.0);
        makeButton(f, "Center", 1, 1, 1, 1, 1.0, 1.0);
        f.pack();
        f.show();
    }

    static void makeTableLayout() {
        Frame f = new Frame("GridBagLayout Example 3");

        f.setLayout(new GridBagLayout());
        makeButton(f, new Label("Name:"), 0, 0, 1, 1, 0.0, 0.0);
        makeButton(f, new Label("Address:"), 0, 1, 1, 1, 0.0, 0.0);
        makeButton(f, new Label("Phone:"), 0, 2, 1, 1, 0.0, 0.0);
        makeButton(f, new TextField("0", 5), 1, 0, 1, 1, 1.0, 0.0);
        makeButton(f, new TextField("0", 5), 1, 1, 1, 1, 1.0, 0.0);
        makeButton(f, new TextField("0", 5), 1, 2, 1, 1, 1.0, 0.0);
        f.pack();
        f.show();
    }
    
    static void makeButton(Container cont, Object arg,
            int x, int y, int w, int h, double weightx, double weighty) {
        GridBagLayout gbl = (GridBagLayout)cont.getLayout();
        GridBagConstraints c = new GridBagConstraints();
        Component comp;

        c.fill = GridBagConstraints.BOTH;
        c.gridx = x;
        c.gridy = y;
        c.gridwidth = w;
        c.gridheight = h;
        c.weightx = weightx;
        c.weighty = weighty;
        if (arg instanceof String) {
            comp = new Button((String)arg);
        } else {
            comp = (Component)arg;
        }
        cont.add(comp);
        gbl.setConstraints(comp, c);
    }

    static public void main(String[] args) {
        makeCrazyLayout();
        makeBorderLayout();
        makeTableLayout();
    }
}
