import java.awt.*;
import java.awt.image.*;

class Main extends Frame {
    Main(String filename) {
        super("getScaledInstance Example");
        // Retrieve the image.
        add(new ImageCanvas(getToolkit().getImage(filename)), 
            BorderLayout.CENTER); 
        setSize(300, 300);
        show();
    }

    static public void main(String[] args) {
        if (args.length == 1) {
            new Main(args[0]);
        } else {
            System.err.println("usage: java Main <image file>");
        }
    }
}

class ImageCanvas extends Component {
    int scale = 3;
    Image image;
    Image scaledImage;

    ImageCanvas(Image image) {
        this.image = image;
        prepareImage(image, this);
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        int w = image.getWidth(this);
        int h = image.getHeight(this);

        if (w >= 0 || h >= 0) {
            if (g.drawImage(image, 0, 0, this) && scaledImage == null) {
                // The original image has completed loading
                // Get its dimensions and get scaled version
                scaledImage = image.getScaledInstance(w*scale, h*scale, 
                    Image.SCALE_SMOOTH);
            }
        }
        if (scaledImage != null) {
            g.drawImage(scaledImage, w, 0, this);
        }
    }
}
