import java.awt.*;
import java.awt.event.*;
import java.util.TooManyListenersException;

class Main extends Frame implements ActionListener, ItemListener {
    OnOffMenuItem mi;

    Main() {
        super("MenuItem Example");
        MenuBar mb = new MenuBar();
        Menu m = new Menu("File");

        mi = new OnOffMenuItem("New");
        m.add(mi);

        try {
            mi.addMyActionListener(this);
        } catch (TooManyListenersException e) {
            e.printStackTrace();
            System.exit(1);
        }

        mb.add(m);

        // Set the menu bar on the frame.
        setMenuBar(mb);

        Checkbox cb = new Checkbox("Enable action event", true);
        cb.addItemListener(this);
        add(cb, BorderLayout.SOUTH);

        setSize(100, 100);    
        show();
    }

    // Action handler for menu item
    public void actionPerformed(ActionEvent evt) {
        System.out.println(evt.getActionCommand());
    }

    // Item handler for checkbox
    public void itemStateChanged(ItemEvent evt) {
        if (evt.getStateChange() == ItemEvent.SELECTED) {
            mi.on();
        } else {
            mi.off();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}

class OnOffMenuItem extends MenuItem {
    ActionListener myListener;

    OnOffMenuItem(String label) {
        super(label);
    }

    void on() {
        enableEvents(AWTEvent.ACTION_EVENT_MASK);
        addActionListener(myListener);
    } 

    void off() {
        disableEvents(AWTEvent.ACTION_EVENT_MASK);
        removeActionListener(myListener);
    }

    public synchronized void addMyActionListener(ActionListener l) 
        throws TooManyListenersException {
        if (myListener != null) {
            throw new TooManyListenersException("OnOffMenuItem");
        }
        myListener = l;
        addActionListener(l);
    }
}
