import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    int dotSize = 10;
    Point[] pts = new Point[100];

    Main() {
        super("Point Example");
        for (int i=0; i<pts.length; i++) {
            pts[i] = new Point();
        }
        setForeground(Color.red);

        // Add mouse motion listener for frame
        addMouseMotionListener(new MouseMotionHandler());
        setSize(200, 200);
        show();
    }

    // Returns a random integer in the range [0..r-1].
    int random(int r) {
        r = Math.max(r, 0);
        return (int)(Math.floor(Math.random()*r));
    }

    public void paint(Graphics g) {
        Insets insets = getInsets();
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;

        for (int i=0; i<pts.length; i++) {
            pts[i].setLocation(random(w-dotSize), random(h-dotSize));
        }
    }

    public void update(Graphics g) {
        for (int i=0; i<pts.length; i++) {
            if (pts[i].x < 0) {
                g.fillOval(-pts[i].x, -pts[i].y, dotSize, dotSize);
            }
        }
    }

    // Mouse motion handler for movement within frame
    class MouseMotionHandler extends MouseMotionAdapter {
        public void mouseMoved(MouseEvent evt) {
            int x = evt.getX();
            int y = evt.getY();
            Point p = new Point(x-dotSize/2, y-dotSize/2);
        
            for (int i=0; i<pts.length; i++) {
                if (p.equals(pts[i])) {
                    pts[i].x = -pts[i].x;
                    pts[i].y = -pts[i].y;
                    repaint();
                    break;
                }
            }
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
