import java.awt.*;
import java.awt.event.*;

public class Main 
    extends Frame 
    implements 
        ActionListener {
    Label l = new Label();
    MainCanvas cv = 
        new MainCanvas(l);

    Main() {
        super("Polygon Example");
        Panel p = new Panel(new GridLayout(1, 0));

        Button b;
        p.add(b = new Button("New"));
        b.addActionListener(this);
        p.add(b = new Button("Flip Ver"));
        b.addActionListener(this);
        p.add(b = new Button("Flip Hor"));
        b.addActionListener(this);
        p.add(b = new Button("Shift"));
        b.addActionListener(this);

        add(p, BorderLayout.SOUTH);

        cv.setSize(300, 300);
        add(cv, BorderLayout.CENTER);
        add(l, BorderLayout.NORTH);
        pack();
        show();
    }
    
    // Action handler for buttons
    public void actionPerformed(ActionEvent evt) {
        String what = evt.getActionCommand();
        if ("New".equals(what)) {
            cv.polygon = null;
        } else if (cv.polygon != null) {
            if ("Shift".equals(what)) {
                cv.polygon.translate(5, 5);
            } else {
                boolean ver =  "Flip Ver".equals(what);
                Rectangle r = cv.polygon.getBounds();

                r.add(0, 0);
                for (int i=0; i<cv.polygon.npoints; i++) {
                    if (ver) {
                        cv.polygon.ypoints[i] = r.height - cv.polygon.ypoints[i];
                    } else {
                        cv.polygon.xpoints[i] = r.width - cv.polygon.xpoints[i];
                    }
                }
            }
        }
        cv.repaint();
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    Label label;
    Polygon polygon;

    MainCanvas(Label label) {
        this.label = label;
        addMouseMotionListener(new MouseMotionHandler());
    }

    // Returns a random number in the range [0..r-1].
    int random(int r) {
        return (int)(Math.floor(Math.random()*r));
    }

    public void paint(Graphics g) {
        int w = getSize().width;
        int h = getSize().height;

        if (polygon == null) {
            polygon = new Polygon();
            for (int i=0; i<25; i++) {
                // Points need to be one pixel from the
                // right and bottom edges otherwise the polygon
                // will extend outside the canvas bounds.
                polygon.addPoint(random(w-1), random(h-1));
            }
        }
        g.fillPolygon(polygon);
    }

    // Mouse motion handler for canvas
    class MouseMotionHandler extends MouseMotionAdapter {
        public void mouseMoved(MouseEvent evt) {
            if (polygon != null) {
                label.setText("contains: " + 
                    polygon.contains(evt.getX(), evt.getY()));
            }
        }
    }

}
