import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    ScrollPane sp = new ScrollPane();
    Button fullviewBtn = new Button("FullView");
    Circle circle = new Circle();

    Main() {
        super("getViewportSize Example");

        fullviewBtn.addActionListener(this);
        // Layout and show the components.
        sp.add(circle);
        add(sp, BorderLayout.CENTER);
        add(fullviewBtn, BorderLayout.NORTH);
        setSize(200, 150);
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        Dimension d = sp.getViewportSize();
        Dimension cd = circle.getSize();
        int dW = cd.width - d.width;
        int dH = cd.height - d.height;

        // Take into account the width of the scrollbar if necessary.
        dW -= (dH > 0) ? sp.getVScrollbarWidth() : 0;
        dH -= (dW > 0) ? sp.getHScrollbarHeight() : 0;

        setSize(getSize().width + dW, getSize().height + dH);
        validate();
        fullviewBtn.setEnabled(false);
    }

    public void doLayout() {
        super.doLayout();

        Dimension d = sp.getViewportSize();
        fullviewBtn.setEnabled(
            d.width < circle.getPreferredSize().width
            || d.height < circle.getPreferredSize().height);
    }

    public static void main(String args[]) {
        new Main();
    }
}

class Circle extends Component {
    Dimension size = new Dimension(200, 200);

    public Dimension getPreferredSize() {
        return size;
    }

    public void paint(Graphics g) {
        g.setColor(Color.lightGray);
        g.fillRect(0, 0, getSize().width, getSize().height);

        // Center the painted circle.
        g.setColor(Color.red);
        g.fillOval((getSize().width-size.width)/2, 
            (getSize().height-size.height)/2, size.width-1, size.height-1);
    }
}
