import java.beans.*;
import java.util.*;

public class BeanBeanInfo extends SimpleBeanInfo {
    public BeanDescriptor getBeanDescriptor() {
        BeanDescriptor bd = new BeanDescriptor(Bean.class);

        bd.setName("Red Bean");
        bd.setExpert(true);
        bd.setHidden(true);

        // Pretend we're in the French locale.
        ResourceBundle bundle = ResourceBundle.getBundle("redbean", 
            Locale.FRENCH);

        // Get the localized color name.
        String name = bundle.getString("red");

        // Modify the name by capitalizing it and then appending " Bean";
        name = Character.toUpperCase(name.charAt(0)) + name.substring(1) 
            + " Bean";
        bd.setDisplayName(name);

        // Get the localized short description.
        bd.setShortDescription(bundle.getString("description"));
        return bd;
    }
}
