import java.awt.*;
import java.beans.*;

class Main {
    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("Usage: java Main <name of bean class file>");
            System.exit(1);
        }

        try {
            // Get the bean class and customizer class.
            // (See the Introspector class example for FileClassLoader 
            // source code.)
            Class beanClass = FileClassLoader.load(args[0]);
            BeanInfo beanInfo = Introspector.getBeanInfo(beanClass);
            BeanDescriptor beanDesc = beanInfo.getBeanDescriptor();
            Class customizerClass = (Class)beanDesc.getCustomizerClass();
    
            if (customizerClass != null) {
                try {
                    // Instantiate the bean and customizer.
                    Object bean = beanClass.newInstance();
                    Customizer customizer = 
                        (Customizer) customizerClass.newInstance();
    
                    // Initialize the customizer.
                    customizer.setObject(bean);

                    // Create a frame for the customizer.
                    Frame frame = new Frame("BeanDescriptor Example");
                    frame.add((Component)customizer);
                    frame.pack();
                    frame.show();
                } catch (InstantiationException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            
        } catch (IntrospectionException e) {
            e.printStackTrace();
        }
    }
}
