import java.awt.*;
import java.awt.event.*;
import java.beans.*;

class Main extends Frame implements ItemListener {
    static Bean bean;
    Checkbox designTimeCb = 
        new Checkbox("DesignTime", true);

    Main() {
        super("Beans Example");

        // Listen for action events.
        designTimeCb.addItemListener(this);

        // Layout components.
        add(bean, BorderLayout.CENTER);
        add(designTimeCb, BorderLayout.SOUTH);
        setSize(200, 200);
        show();

        // We are responsible for starting the bean.
        bean.start();
    }

    public void itemStateChanged(ItemEvent evt) {
        Beans.setDesignTime(designTimeCb.getState());
        ((Component)bean).repaint();
    }

    public static void main(String[] args) {
        // Initialize the environment in design-time mode.
        Beans.setDesignTime(true);

        try {
            // Create the bean.
            bean = (Bean)Beans.instantiate(Main.class.getClassLoader(), "Bean");

            new Main();
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Failed to create bean.");
            System.exit(1);
        }
    }
}

