import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class NamesCustomEditor extends Panel implements ActionListener {
    PropertyEditor pe;
    List list = new List(10);
    TextField textField = new TextField(5);

    public NamesCustomEditor(PropertyEditor pe, String[] names) {
        Button saveBtn = new Button("Save");
        Button removeBtn = new Button("Remove");
        Button addBtn = new Button("Add");

        this.pe = pe;

        // Initialize list.
        for (int i=0; i<names.length; i++) {
            list.add(names[i]);
        }
        
        // Layout the components.
        setLayout(new BorderLayout());
        list.setSize(250, 150);
        add(list, BorderLayout.CENTER);
        Panel p = new Panel();
        p.add(saveBtn);
        p.add(removeBtn);
        p.add(addBtn);
        p.add(textField);
        add(p, BorderLayout.SOUTH);

        // Listen for events
        textField.addActionListener(this);
        saveBtn.addActionListener(this);
        removeBtn.addActionListener(this);
        addBtn.addActionListener(this);
    }
    
    public void actionPerformed(ActionEvent evt) {
        if (evt.getActionCommand().equals("Remove")) {
            int sel = list.getSelectedIndex();
            
            if (sel >= 0) {
                list.remove(sel);
            }
        } else if (evt.getActionCommand().equals("Save")) {
            // Save the changes.
            String[] names = new String[list.getItemCount()];
            for (int i=0; i<names.length; i++) {
                names[i] = list.getItem(i);
            }
            pe.setValue(names);
        } else if (evt.getActionCommand().equals("Add")
                || evt.getSource() == textField) {
            list.add(textField.getText());
        } 
    }
}
