import java.awt.*;
import java.beans.*;
import java.util.*;

public class NamesEditor extends PropertyEditorSupport {
    // Paint area methods.
    public boolean isPaintable() {
        return true;
    }
    public void paintValue(Graphics g, Rectangle box) {
        String[] names = (String[])getValue();
        FontMetrics fm = g.getFontMetrics();
        String message  = "" + names.length + " names";

        // There's a bug in the bean box where box width and height 
        // are too big by 4 pixels.
        box.width -= 4;
        box.height -= 4;

        g.setColor(Color.black);
        g.drawString(message, (box.width-fm.stringWidth(message))/2,
            (box.height-fm.getHeight())/2 + fm.getAscent());
        g.drawRect(box.x, box.y, box.width-1, box.height-1);
    }

    // Custom editor methods.
    public boolean supportsCustomEditor() {
        return true;
    }
    public java.awt.Component getCustomEditor() {
        return new NamesCustomEditor(this, (String[])getValue());
    }
}

