import java.beans.*;
import java.text.*;
import java.util.*;

// This property editor allows the user to edit the date 
// in the default locale, using the SHORT format.

public class DateEditor extends PropertyEditorSupport {
    public String getAsText() {
        return DateFormat.getDateInstance(
            DateFormat.SHORT, Locale.getDefault()).format(((Date)getValue()));
    }

    public void setAsText(String text) throws IllegalArgumentException {
        try {
            setValue(DateFormat.getDateInstance(
                DateFormat.SHORT, Locale.getDefault()).parse(text));
            return;
        } catch (Exception e) {
            // It doesn't matter what the exception is.
        }
        throw new IllegalArgumentException(text);
    }
}